package com.remotejmx.client;

import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

import javax.management.*;

import javax.management.remote.*;

public class RemoteJMXClient {
//   private MBeanServer mbs = null;
   private MBeanServerConnection mbsc = null;

   public RemoteJMXClient() {

      // Get the platform MBeanServer
//      mbs = ManagementFactory.getPlatformMBeanServer();

      try {
         // Create an RMI connector and start it
         JMXServiceURL url = new JMXServiceURL("service:jmx:rmi:///jndi/rmi://localhost:8999/jmxrmi");

         Map map = new HashMap();
         String[] credentials = new String[] { "monitorRole" , "QED" }; 
         map.put("jmx.remote.credentials", credentials);
         
         JMXConnector conn = JMXConnectorFactory.connect(url, map);
         System.out.println("JMXConnector="+conn.toString());
         
         String id = conn.getConnectionId();
         System.out.println("Connection Id=" + id);
         
         mbsc = conn.getMBeanServerConnection();
         String domains[] = mbsc.getDomains();
         System.out.println("# of domains="+domains.length);
         for (int i = 0; i < domains.length; i++) { 
            System.out.println("Domain[" + i + "] = " + domains[i]); 
         }
         
         // Get MBean count
         Integer mbeanCount = mbsc.getMBeanCount();
         System.out.println("mbeanCount : " + mbeanCount.intValue());

         Set mBeanSet = mbsc.queryMBeans(null, null);
         System.out.println("mBeanSet.size() : " + mBeanSet.size());

         Iterator mBeanSetIterator = mBeanSet.iterator();
         while (mBeanSetIterator.hasNext()) {
            ObjectInstance objectInstance = (ObjectInstance)mBeanSetIterator.next();
            ObjectName objectName = objectInstance.getObjectName();
            String canonicalName = objectName.getCanonicalName();
            System.out.println("canonicalName : " + canonicalName);
            
            if (canonicalName.equals("Catalina:host=localhost,type=Cluster"))
            {
            	System.out.println(objectInstance.getClassName());

            	String objName = "";
            	// Get details of cluster MBean
                System.out.println("Cluster MBean Details:");
                System.out.println("=========================================");
//                objName = "Catalina:host=localhost,name=SimpleTcpCluster,type=Cluster";
                objName = "Catalina:host=localhost,type=Cluster";
                getMBeanDetails(objName);
            }

            String canonicalKeyPropList = objectName.getCanonicalKeyPropertyListString();
         }
         
         conn.close();

         
      } catch(Exception e) {
         e.printStackTrace();
      }
   }
   
   public void getMBeanDetails(String objName) {
	   try {
		   ObjectName objectName = new ObjectName(objName);
			ObjectInstance objectInstance = mbsc.getObjectInstance(objectName);
			System.out.println("objectInstance : " + objectInstance);

			MBeanInfo mbeanInfo = mbsc.getMBeanInfo(objectName);
			System.out.println("mbeanInfo : " + mbeanInfo);

			MBeanAttributeInfo[] attributes = mbeanInfo.getAttributes();
			System.out.println("MBean Attributes:");
			String[] attributeNames = new String[attributes.length];
			for (int i = 0; i < attributes.length; i++) {
				System.out.println(i + ": " + attributes[i].getName() + " "
						+ attributes[i].getType());
				attributeNames[i] = attributes[i].getName();
			}

	         AttributeList attributeList = mbsc.getAttributes(objectName, attributeNames);
	         Iterator it = attributeList.iterator();
	         System.out.println("Attributes of " + objectName.getCanonicalName() + " : ");
	         while (it.hasNext()) {
	            Attribute attribute = (Attribute)it.next();
	            System.out.println(attribute.getName() + " : " + attribute.getValue());
	         }
	         System.out.println("");
	      } catch (Exception e) {
	         e.printStackTrace();
	      }
	   }
   
  public static void main(String argv[]) {
      RemoteJMXClient agent = new RemoteJMXClient();
      System.out.println("RemoteJMXClient is running...");
   }
}