package com.clusterapp.listeners;

import javax.servlet.ServletContextListener;
import javax.servlet.ServletContextAttributeListener;
import javax.servlet.ServletContext;
import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextAttributeEvent;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public final class ClusterAppContextListener implements ServletContextListener,
        ServletContextAttributeListener {

    private static Log sLog = LogFactory.getLog(ClusterAppContextListener.class);

    private static ServletContext context = null;

    public ClusterAppContextListener() {
    }

    //This method is invoked when the Web Application
    //is ready to service requests
    public void contextInitialized(ServletContextEvent event) {
        context = event.getServletContext();
        //Output a simple message to the server's console
        System.out.println("ClusterApp context is created.");
        sLog.debug("LOG4J: ClusterApp context is created.");

    }

    //This method is invoked when the Web Application
    //has been removed and is no longer able to accept
    //requests
    public void contextDestroyed(ServletContextEvent event) {
        //Output a simple message to the server's console
        System.out.println("ClusterApp context is removed.");
        sLog.debug("LOG4J: ClusterApp context is removed.");
        context = null;
    }

    //This method is invoked when an attribute
    //is added to the ServletContext object
    public void attributeAdded(ServletContextAttributeEvent event) {
        //		System.out.println("An attribute was added to ServletContext
        // object.");
    }

    //This method is invoked when an attribute
    //is removed from the ServletContext object
    public void attributeRemoved(ServletContextAttributeEvent event) {
        //   	System.out.println("An attribute was removed from ServletContext
        // object.");
    }

    //This method is invoked when an attribute
    //is replaced in the ServletContext object
    public void attributeReplaced(ServletContextAttributeEvent event) {
        //   	System.out.println("An attribute was replaced in ServletContext
        // object.");
    }

    public static ServletContext getServletContext() {
        return context;
    }

    public static String getWebPortalContextPath() {
        return context.getRealPath("");
    }
}
// End of ClusterAppContextListener.java
